/*********************************
 * PC-Karel 4.0.b9
 * (C) 1991-2001 Jiri Osoba
 * osoba@email.cz
 * port z Win32 na PalmOS
 * (C) JUN-JUL 2001 Hynek Sladky
 * sladky@mujmail.cz
 *********************************/

#pragma pack(2)
//#include <Common.h>
//#include <System/SysAll.h>
//#include <System/KeyMgr.h>
//#include <UI/UIAll.h>
#include <PalmOS.h>

#include "kar_rsc.h"
#include "karel.h"

/*
UKOLY:
*/

// forward function definitions

// global definitions
#define MAX_X           10
#define MAX_Y           10

#define ZED             (MAX_ZNACEK_m+1)
#define MAX_ZNACEK_d    7
#define MAX_ZNACEK_m    9
#define MAX_SL          10000
#define MAX_JM          255
#define POC_SLOVNIK     13
#define POC_SYSY        5
#define MAX_STACK       10000
#define MAX_PODMINEK    12
#define POC_PODMINEK    43

#define DEF_PAUSE       10

// type definitions
typedef enum {
    DEK_NONE = -POC_SYSY - 1,
    DEK_NACTI, DEK_ULOZ, DEK_SMAZ,
//    DEK_KOPENOGRAM,
    DEK_OPRAV, DEK_DEKADICKY,
//    DEK_TISKNI, DEK_NETISKNI,
    DEK_UNKNOWN,
    DEK_SLOVNIK, DEK_MESTO, DEK_ROZKLAD, DEK_CHYBA,
    DEK_KROK, DEK_VLEVO_VBOK, DEK_POLOZ, DEK_ZVEDNI,
    DEK_KDYZ, DEK_DOKUD, DEK_OPAKUJ, DEK_KONEC
} DEK;

typedef enum {
    SYSY_NACTI, SYSY_ULOZ, SYSY_SMAZ,
//    SYSY_KOPENOGRAM,
    SYSY_OPRAV,
//    SYSY_TISKNI, SYSY_NETISKNI
    SYSY_DEKADICKY
} SYSY;

// kvuli ulozeni rozdelane prace musim vytvorit strukturu

// global variables definitions
int                     x, y, smer;
int                     mode;
unsigned char           dvorek[MAX_X][MAX_Y];
unsigned char           *txt[MAX_TXT_RC];
unsigned char           *sl;
unsigned char           *sysy[POC_SYSY], *podm[MAX_PODMINEK], *je_neni[2], *jm[MAX_JM];
int                     free_pos, free_no, sat[MAX_JM], chyba, pause;//, line;
long                    last_time;

// PalmOS implementation definitions
#define CalcX(x)        MestoX+Okraj+x*Modul
#define CalcY(y)        MestoY+Okraj+(MAX_Y-y-1)*Modul
#define LineLen         40
#define CmdLen          15
#define EditLen         4000
#define NameLen         31
//#define NameCnt         32
#define NameCnt         MAX_JM

// PalmOS implementation defines
#define EditType        0x01
#define SaveType        0x02
#define EditMode        0x04
#define RunMode         0x10

// PalmOS implementation variables
WinHandle               bitwin;
int                     lst_cnt, paus_pos, MAX_ZNACEK; //lpos, edit_mode, run_mode;
char                    cmd[CmdLen+1], *cmd_par, *edit_mem; //cmdline[LineLen+1]
char                    *lists[NameCnt];
MemHandle               txthnd[MAX_TXT_RC], sl_hnd, lst_hnd, edit_hnd, cmdline;
DmOpenRef               mestoDB, slovnikDB;
char                    *mestoName="MestoProKarla";
char                    *slovnikName="SlovnikProKarla";
UInt16                  slovIdx, mestIdx;
struct {
  int   x, y, smer, paus_pos;
  UInt16 slovIdx, mestIdx;
} prefs;

/***************************************************************************
 *      O b e c n e   F u n k c e                                          *
 ***************************************************************************/

// nakresleni jedne pozice mesta
void TiskPole (int x, int y, int smer, int co) {
RectangleType rect;
  if (co>MAX_ZNACEK_m) co=MAX_ZNACEK_m+1;
  rect.topLeft.x=co*Modul; rect.topLeft.y=0; rect.extent.x=rect.extent.y=Modul;
  WinCopyRectangle (bitwin, NULL, &rect, CalcX(x), CalcY(y), winPaint);
  if (smer) {
    rect.topLeft.x=karel_bmp*Modul;
    WinCopyRectangle (bitwin, NULL, &rect, CalcX(x), CalcY(y), winMask);
    rect.topLeft.x=(karel_bmp+smer)*Modul;
    WinCopyRectangle (bitwin, NULL, &rect, CalcX(x), CalcY(y), winOverlay);
  }
}

void HlasChybu (UInt16 id, char *s1, char *s2, char *s3) {
  if (s1==NULL && s2==NULL && s3==NULL)
    FrmAlert (id);
  else
    FrmCustomAlert (id, s1, s2, s3);
  chyba++;
}

void NactiJmena (DmOpenRef database) {
void* hndl;

  for (lst_cnt=0; lst_cnt<NameCnt && lst_cnt<DmNumRecords (database); lst_cnt++) {
    StrCopy (lists[lst_cnt], MemHandleLock (hndl=DmQueryRecord (database, lst_cnt)));
    MemHandleUnlock (hndl);
  }
}


/***************************************************************************
 *      M E S T O                                                          *
 ***************************************************************************/

void NactiMesto(UInt16 index) {
char            *ptr;

  if (index<0) return;
  ptr=MemHandleLock (DmQueryRecord (mestoDB, index));
  MemMove (dvorek, &ptr[NameLen+1], sizeof (dvorek));
  MemPtrUnlock (ptr);
}

void UlozMesto(void) {
UInt16          index;
void            *ptr;

  if (!*edit_mem) return;
  for (index=0; index<NameCnt; index++) {
    if (!StrCompare (edit_mem, lists[index])) break;
  }
  if (index>=NameCnt) {
    index=dmMaxRecordIndex;
    ptr=MemHandleLock (DmNewRecord (mestoDB, &index, NameLen+1+sizeof (dvorek)));
  } else {
    ptr=MemHandleLock (DmResizeRecord (mestoDB, index, NameLen+1+sizeof (dvorek)));
  }
  DmWrite (ptr, 0, edit_mem, NameLen+1);
  DmWrite (ptr, NameLen+1, dvorek, sizeof (dvorek));
  MemPtrUnlock (ptr);
  DmReleaseRecord (mestoDB, index, true);
  mestIdx=index;
}

#define Tisk            0
#define Mazani          1
#define Zvednuti        2

void TiskniMesto (int akce) {
int i, j;

  if (akce==Mazani) {smer=x=y=0;}
  for (i=0; i<MAX_X; i++) {
    for (j=0; j<MAX_Y; j++) {
      switch (akce) {
	case 1: dvorek[i][j]=0; break;
	case 2: if (dvorek[i][j]<=MAX_ZNACEK_m) dvorek[i][j]=0; break;
      }
      TiskPole (i, j, (x==i && y==j && !(mode&EditType) ? smer+1: 0), dvorek[i][j]);
    }
  }
}

/***************************************************************************
 *      P O D M I N K Y                                                    *
 ***************************************************************************/

int Splneno(int podminka) {
int spl, podm;

  spl=0;
  podm=podminka % 80;
  if (podm == 0)
    switch (smer) {
      case 0:
	spl = (x == MAX_X - 1) || (dvorek[x + 1][y] == ZED);
	break;
      case 1:
	spl = (y == MAX_Y - 1) || dvorek[x][y + 1] == ZED;
	break;
      case 2:
	spl = (x == 0) || dvorek[x - 1][y] == ZED;
	break;
      case 3:
	spl = (y == 0) || dvorek[x][y - 1] == ZED;
	break;
    } else
    if (podm == 1)
      spl = dvorek[x][y];
    else
    if (podm < 6)
      spl = !(podm - smer - 2);
    else
    if (podm == 6)
      spl=(KeyCurrentState ()&keyBitPageUp);
    else
    if (podm == 7)
      spl = dvorek[x][y] >= MAX_ZNACEK;
    else
    if (podm < 17)
      spl = podm - 7 == dvorek[x][y];
    else
    if (podm < 27)
      spl = podm - 17 == x;
    else
    if (podm < 42)
      spl = podm - 27 == y;
    else
    if (podm == 42)
      spl = SysRandom (0) & 1;
    if (podminka / 80)
      spl = !spl;
    return (spl);
}

char *Podm(int jaka) {

  if (jaka < 8)
    return (podm[jaka]);
  if (jaka < 17) {
    *podm[8] = 41 + jaka;
    return (podm[8]);
  }
  if (jaka < 27) {
    StrPrintF(podm[9] + 1, "%d", jaka - 16);
    return (podm[9]);
  }
  if (jaka < 42) {
    StrPrintF(podm[10] + 1, "%d", jaka - 26);
    return (podm[10]);
  }
  if (jaka == 42)
    return (podm[11]);
  return ("");
}

/***************************************************************************
 *      S L O V N I K                                                      *
 ***************************************************************************/

void SetSat(void) {
unsigned char *p;

  p=sl;
  free_no = POC_SLOVNIK;
  while (p - sl < free_pos) {
    jm[free_no] = p;
    while (*p++);
    sat[free_no++] = (int) (p - sl);
    while (*p++)
      p++;
  }
}

void VytvorSlovnik(void) {
int i;
char *p;

  for (i = 0, p = txt[TXT_PODMINKY-TXT_SLOVNIK]; *p; i++) {
    podm[i] = p;
    while (*p++);
  }
  for (i = 0, p = txt[TXT_JENENI-TXT_SLOVNIK]; *p; i++) {
    je_neni[i] = p;
    while (*p++);
  }
  for (i = 0, p = txt[TXT_SLOVNIK-TXT_SLOVNIK]; *p; i++) {
    jm[i] = p;
    while (*p++);
  }
  for (i = 0, p = txt[TXT_SYSY-TXT_SLOVNIK]; i < POC_SYSY; i++) {
    sysy[i] = p;
    while (*p++);
  }
  free_pos = 0;
  SetSat();
}

#define SHOW_SYSY       1
#define SHOW_BUILTIN    2

int VypisSlovnik (FormPtr frm, int cat) {
int i;
ListPtr lst;

  lst_cnt=0;
  if (cat&SHOW_SYSY)
    for (i = 0; i < POC_SYSY; i++)
      StrCopy (lists[lst_cnt++], sysy[i]);
  for (i = (cat&SHOW_BUILTIN)?1:POC_SLOVNIK; i < free_no; i++)
    StrCopy (lists[lst_cnt++], jm[i]);
  LstSetListChoices (lst=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, slov_list)), lists, lst_cnt);
  LstSetSelection (lst, lst_cnt-1);
  LstMakeItemVisible (lst, lst_cnt-1);
  return LstPopupList (lst);
}
/*
void VypisSlovnik(void) {
int i;
char *s;

  s=edit_mem;
  for (i = 0; i < POC_SYSY; i++)
    s+=StrPrintF (s, "%s\n", sysy[i]);
  s+=StrPrintF (s, "\n");
  for (i = 1; i < free_no; i++)
    s+=StrPrintF (s, "%s\n", jm[i]);
  if (s>edit_mem) {s--; *s=0;} // smazu posledni \n
//  s+=StrPrintF (s, "\n");
}
*/
void NactiSlovnik (UInt16 index) {
char    *ptr;

  if (index<0) return;
  ptr=MemHandleLock (DmQueryRecord (slovnikDB, index));
  MemMove (sl, &ptr[NameLen+1], free_pos=(MemPtrSize (ptr)-NameLen-1));
  MemPtrUnlock (ptr);
  SetSat();
}

void UlozSlovnik (void) {
UInt16          index;
void            *ptr;

  if (!*edit_mem) return;
  for (index=0; index<NameCnt; index++) {
    if (!StrCompare (edit_mem, lists[index])) break;
  }
  if (index>=NameCnt) {
    index=dmMaxRecordIndex;
    ptr=MemHandleLock (DmNewRecord (slovnikDB, &index, NameLen+1+free_pos));
  } else {
    ptr=MemHandleLock (DmResizeRecord (slovnikDB, index, NameLen+1+free_pos));
  }
  DmWrite (ptr, 0, edit_mem, NameLen+1);
  DmWrite (ptr, NameLen+1, sl, free_pos);
  MemPtrUnlock (ptr);
  DmReleaseRecord (slovnikDB, index, true);
  slovIdx=index;
}

// funkce pro parsovani jednotlivych slov
char *StrCopyWord (char *dest, char *src) {
  cmd_par=dest;
  while (*src>' ') {
    *cmd_par=*src;
    src++; cmd_par++;
  }
  if (*src) src++;
  *cmd_par=0;
  cmd_par=src;
  while (*cmd_par && *cmd_par<=' ') {
//    if (*cmd_par=='\n') line++;
    cmd_par++;
  }
  return (dest);
}

int StrCmp(char *a, char *b) {
  do {
    if (*a == '.')
      break;
    if (!*b && *a<=' ')
      break;
    if (*a != *b)
      return (0);
//    a++; b++;
//  } while (*b);//(*b && *a);
  } while (b++, *a++);
  if (*b && *a) a++;
//  while (*a<=' ') {if (*a=='\n') line++; a++;}
//  cmd_par=a;
  return (1);
}

int Dekoduj(char *a) {
int i;

  if (!*a)
    return (DEK_NONE);
  for (i = 1; i < POC_SLOVNIK; i++)
    if (StrCmp (a, jm[i]))
      return (i);
  for (i = 0; i < POC_SYSY; i++)
    if (StrCmp (a, sysy[i]))
      return (DEK_NACTI + i);
  for (i = POC_SLOVNIK; i < free_no; i++)
    if (StrCmp (a, jm[i]))
      return (i);
  return (DEK_UNKNOWN);
}

/***************************************************************************
 *      P R I M I T I V A                                                  *
 ***************************************************************************/

void Vlevo(void) {
  TiskPole(x, y, (smer = (smer + 1) & 3) + 1, dvorek[x][y]);
}

void Krok(void) {
  if (Splneno(0))
    HlasChybu(TXT_NJSEM, NULL, NULL, NULL);
  else {
    TiskPole(x, y, 0, dvorek[x][y]);
    switch (smer) {
      case 0:
	x++;
	break;
      case 1:
	y++;
	break;
      case 2:
	x--;
	break;
      case 3:
	y--;
	break;
      }
      TiskPole(x, y, smer + 1, dvorek[x][y]);
  }
}

void Poloz(void) {
  if (Splneno(7))
    HlasChybu(TXT_NKPOLOZIT, NULL, NULL, NULL);
  else
    TiskPole(x, y, smer + 1, ++dvorek[x][y]);
}

void Zvedni(void) {
  if (!Splneno(1))
    HlasChybu(TXT_NCZVEDNOUT, NULL, NULL, NULL);
  else
    TiskPole(x, y, smer + 1, --dvorek[x][y]);
}

/***************************************************************************
 *      V Y K O N A V A N I                                                *
 ***************************************************************************/

unsigned short NajdiKonec(unsigned short ptr) {
int level;

  for (level = 0; 1; ptr += 2)
    switch (sl[ptr]) {
      case DEK_KDYZ:
	level++;
      case DEK_DOKUD:
      case DEK_OPAKUJ:
	level++;
	break;
      case DEK_KONEC:
	if (level)
	  level--;
	else
	  return (ptr);
    }
}

int TestKbd (void);

void Delay (void) {
long act_time;

  last_time += pause;
  do {
    act_time = TimGetTicks ();
  } while (act_time < last_time);
}

typedef unsigned short STACK;

void JedPrikaz(int n) {
unsigned short  ptr, stack_ptr;
STACK           *stack;
void*           hndl;
Int16           dummy;

  stack_ptr=0;
  stack = (STACK *) MemHandleLock (hndl=MemHandleNew (MAX_STACK * sizeof(STACK)));
  if (stack == NULL)
    return;
  last_time = TimGetTicks ();
  SclGetScrollBar (FrmGetObjectPtr (FrmGetActiveForm (), FrmGetObjectIndex (FrmGetActiveForm (), main_scroll)), (Int16*)&paus_pos, &dummy, &dummy, &dummy);
  dummy=paus_pos;
  pause=0; while (dummy--) pause+=(pause/6+1);
  ptr = sat[n];
  mode|=RunMode;
  for (chyba = 0; !TestKbd(); ptr += 2) {
    if (stack_ptr > MAX_STACK - 2)
      HlasChybu(TXT_NEBAVI, NULL, NULL, NULL);
    else
    switch (sl[ptr]) {
      case DEK_KROK:
	Krok();
	Delay();
	break;
      case DEK_VLEVO_VBOK:
	Vlevo();
	Delay();
	break;
      case DEK_POLOZ:
	Poloz();
	Delay();
	break;
      case DEK_ZVEDNI:
	Zvedni();
	Delay();
	break;
      case DEK_KDYZ:
	stack[stack_ptr++] = NajdiKonec(NajdiKonec(ptr + 2) + 2);
	if (!Splneno(sl[ptr + 1]))
	  ptr = NajdiKonec(ptr + 2);
	break;
      case DEK_DOKUD:
	if (Splneno(sl[ptr + 1]))
	  stack[stack_ptr++] = ptr - 2;
	else
	  ptr = NajdiKonec(ptr + 2);
	break;
      case DEK_OPAKUJ:
	stack[stack_ptr++] = ptr;
	stack[stack_ptr++] = 0x8000 + sl[ptr + 1];
	break;
      case DEK_KONEC:
	if (stack_ptr) {
	  if (stack[--stack_ptr] & 0x8000) {
	    if (stack[stack_ptr] & 0xFF) {
	      if ((--stack[stack_ptr]) & 0xFF)
		ptr = stack[(stack_ptr++) - 1];
	      else
		stack_ptr--;
	    } else {
	      if (Splneno(sl[ptr + 1] - 80)) {
		ptr = stack[(stack_ptr++) - 1];
	      } else
		stack_ptr--;
	    }
	  } else
	  ptr = stack[stack_ptr];
	} else
	  chyba++;
	break;
      default:
	if (sl[ptr + 4])
	  stack[stack_ptr++] = ptr;
	ptr = sat[sl[ptr]] - 2;
	break;
    }
  }
  mode&=~RunMode;
  MemHandleUnlock (hndl);
  MemHandleFree (hndl);
}

/***************************************************************************
 *      R O Z K L A D                                                      *
 ***************************************************************************/

void Rozklad(int n, char *out) {
int indent;
char *s;

  indent=2;
  s=out;
  s+=StrPrintF (s, "%s %s\n", jm[n], txt[TXT_ZNAMENA-TXT_SLOVNIK]);
  n = sat[n];
  while (sl[n]) {
    switch (sl[n]) {
      case DEK_KDYZ:
      case DEK_DOKUD:
	s+=StrPrintF (s, "%*s%s %s %s\n", indent, "", jm[sl[n]], je_neni[(sl[n + 1]) / 80], Podm((sl[n + 1]) % 80));
	indent += 2;
	break;
      case DEK_OPAKUJ:
	if (sl[n + 1])
	  s+=StrPrintF (s, "%*s%s %d %s\n", indent, "", jm[sl[n]], sl[n + 1], txt[TXT_KRAT-TXT_SLOVNIK]);
	else
	  s+=StrPrintF (s, "%*s%s\n", indent, "", jm[sl[n]]);
	indent += 2;
	break;
      case DEK_KONEC:
	indent -= 2;
	switch (sl[n + 1]) {
	  case 0:
	    s+=StrPrintF (s, "%*s%s\n", indent, "", jm[sl[n]]);
	    break;
	  case 1:
	    s+=StrPrintF (s, "%*s%s %s\n", indent, "", jm[sl[n]], txt[TXT_JINAK-TXT_SLOVNIK]);
	    indent += 2;
	    break;
	  default:
	    s+=StrPrintF (s, "%*s%s %s %s\n", indent, "", jm[0], je_neni[(sl[n + 1]) / 80 - 1], Podm((sl[n + 1]) % 80));
	    break;
	}
	break;
      default:
	s+=StrPrintF (s, "%*s%s\n", indent, "", jm[sl[n]]);
	break;
    }
    n += 2;
  }
  s--; *s=0; // zrusi posledni \n
}

/***************************************************************************
 *      D E F I N I C E   P R I K A Z U                                    *
 ***************************************************************************/

int ZvolPodminku (void) {
int i, j;


  if (StrCmp (cmd_par, je_neni[0]) || StrCmp (cmd_par, je_neni[1])) {
    j=StrCmp (StrCopyWord (cmd, cmd_par), je_neni[0]) ? 0 : 1;
  } else j=0;
  StrCopyWord (cmd, cmd_par);
  for (i=0; i<POC_PODMINEK; i++)
    if (StrCmp (cmd, Podm(i)))
      return (i+j*80);
  return (j*80);
}

void DefinujPrikaz (char *b) {
int n, indent, stack[20], stack_ptr, next, free_pos1;
char m, *s;

  indent=2; *stack=1; stack_ptr=1; next=0; free_pos1=free_pos;
  s=b; while (*s) {if (*s>='a' && *s<='z') *s&=0x5F; s++;}
  sat[free_no++] = (free_pos1 += StrLen(jm[free_no] = StrCopyWord(sl + free_pos1, b)) + 1);
  if (StrCmp(cmd_par, txt[TXT_ZNAMENA-TXT_SLOVNIK])) {
    next = 1;
    StrCopyWord (cmd, cmd_par);
  }
  do {
    sl[free_pos1] = 0;
    StrCopyWord (cmd, cmd_par);
    if ((next = n = Dekoduj(cmd)) == 0)
      if (StrCmp(cmd, jm[0]))
	next = n = DEK_KONEC;
    switch (n) {
      case DEK_UNKNOWN:
	HlasChybu(TXT_NEZNAM, cmd, NULL, NULL);
	next = 1;
	break;
      case DEK_CHYBA:
	if (free_pos1 == sat[free_no - 1]) {
//          Tisk1(NULL, 0, txt[TXT_ZRUSENO], jm[--free_no]);
	  free_pos1 = (int) (jm[--free_no] - sl);
	  return;
	}
	switch (sl[free_pos1 -= 2]) {
	  case DEK_KDYZ:
	  case DEK_DOKUD:
	  case DEK_OPAKUJ:
	    indent -= 2;
	    stack_ptr--;
	    break;
	  case DEK_KONEC:
	    if (sl[free_pos1 + 1] == 1)
	      stack[stack_ptr - 1] = 9;
	    else {
	      if ((sl[free_pos1 + 1]) >= 80)
		stack[stack_ptr++] = 0;
	      else
		stack[stack_ptr++] = 1;
	      indent += 2;
	    }
	    break;
	  default:
	    break;
	}
	sl[free_pos1] = 0;
//        Rozklad(free_no - 1, NULL);
	break;
      case DEK_KDYZ:
      case DEK_DOKUD:
	m = ZvolPodminku ();
//        Tisk1(NULL, 0, "%*s%s %s %s", indent, "", jm[n], je_neni[m / 80], Podm(m % 80));
	sl[free_pos1++] = n;
	sl[free_pos1++] = m;
	stack[stack_ptr++] = n;
	indent += 2;
	break;
      case DEK_OPAKUJ:
	if (*cmd_par>='0' && *cmd_par<='9')
	  m = StrAToI(StrCopyWord (cmd, cmd_par));//NextString(in, txt[TXT_KOLIKRAT]));
	else
	  m = 0; // nebudu kopirovat, protoze dalsi neni cislo! Predpokladam OPAKUJ - POKUD
	sl[free_pos1++] = n;
	sl[free_pos1++] = m;
	stack[stack_ptr++] = (m ? 1 : 0);
	if (m != 0) {
//          Tisk1(NULL, 0, "%*s%s %d %s", indent, "", jm[n], m, txt[TXT_KRAT]);
//          if //((b = NextString(in, NULL)) != NULL)
	  if (next = StrCmp(cmd_par, txt[TXT_KRAT-TXT_SLOVNIK]))
	    StrCopyWord (cmd, cmd_par);
	} else {
//          Tisk1(NULL, 0, "%*s%s", indent, "", jm[n]);
	  next = 0;//(*a == 0);
	}
	indent += 2;
	break;
      case DEK_NONE:
	n = DEK_KONEC;
      case DEK_KONEC:
	sl[free_pos1++] = n;
	sl[free_pos1++] = 0;
	switch (stack[--stack_ptr]) {
	case 0:             //OPAKUJ - POKUD
	  sl[free_pos1 - 1] = (m = ZvolPodminku ()) + 80;
//          Tisk1(NULL, 0, "%*s%s %s %s", next=(indent-=2), "", jm[0], je_neni[m / 80], Podm(m % 80));
	  next=indent-=2;
	  break;
	case 9:             //KONEC JINAK
	  sl[free_pos1 - 1] = 1;
//          Tisk1(NULL, 0, "%*s%s %s", indent - 2, "", jm[n], txt[TXT_JINAK]);
	  stack[stack_ptr++] = 1;
//          if ((b = NextString(in, NULL)) != NULL)
	  if (next = StrCmp(cmd_par, txt[TXT_JINAK-TXT_SLOVNIK]))
	    StrCopyWord (cmd, cmd_par);
	  break;
	default:
//          Tisk1(NULL, 0, "%*s%s", next = (indent -= 2), "", jm[n]);
	  indent-=2;
	  break;
	}
	break;
      default:
	if (n < DEK_CHYBA) {
	  HlasChybu(TXT_TNEMOHU, n < 0 ? sysy[n - DEK_NACTI] : jm[n], NULL, NULL);
	  next = 1;
	} else {
	   sl[free_pos1] = n;
	   free_pos1 += 2;
//           Tisk1(NULL, 0, "%*s%s", indent, "", jm[n]);
	}
	break;
    }
  } while (indent);
  sl[free_pos1++] = 0;
  free_pos = free_pos1;
  for (n = free_no - 2; n > DEK_KONEC; n--)
    if (StrCmp(jm[free_no - 1], jm[n])) {
      MemMove (sl + free_pos, jm[n + 1], (int) (jm[free_no - 1] - jm[n + 1]));
      MemMove (jm[n], jm[free_no - 1], (int) (sl + free_pos - jm[n + 1]));
      free_pos -= (int) (jm[n + 1] - jm[n]);
      SetSat();
    }
}

/***************************************************************************
 *      E v e n t   L o o p s                                              *
 ***************************************************************************/

// main event handler
static Boolean MainEventHandler (EventPtr event) {
FormPtr         frm;
FieldPtr        fld;
ListPtr         lst;
int             handled = 0;
int             i, j;
int             c;
char            *s, *t;
EventType       newevent;
UInt16          fldI;
//VoidHand        hndl;
//DmOpenRef       *database;

  frm = FrmGetActiveForm ();
  switch (event->eType) {
// form events
    case frmOpenEvent:
      SclSetScrollBar (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, main_scroll)), paus_pos, scroll_min, scroll_max, scroll_page);
      *(char*)MemHandleLock (cmdline)=0; MemHandleUnlock (cmdline);
      FldSetTextHandle (fld=FrmGetObjectPtr (frm, fldI=FrmGetObjectIndex (frm, main_cmd)), cmdline);
      FrmDrawForm (frm);
      FldSetInsertionPoint (fld, 0);
      FrmSetFocus (frm, fldI);
      TiskniMesto (Tisk);
      handled = 1;
      break;
    case appStopEvent:
    case frmCloseEvent:
      SclGetScrollBar (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, main_scroll)), (Int16*)&paus_pos, (Int16*)&c, (Int16*)&c, (Int16*)&c);
      FldSetTextHandle (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, main_cmd)), NULL);
      break;
// key events
    case keyDownEvent:
      if (mode&RunMode) {handled=1; break;}
      c=event->data.keyDown.chr;
//      if (c>='a' && c<='z') c&=0x5F;
//      if (c<=255 && c>=' ') {
//        if (lpos>=LineLen) break;
//        cmdline[lpos]=c;
//        lpos++;
//        cmdline[lpos]='_'; cmdline[lpos+1]=0;
//        FldSetTextPtr (fld=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, main_cmd)), cmdline);
//        FldDrawField (fld);
//        handled=1;
//      } else
//      if (c==chrBackspace && lpos) {
//        lpos--;
//        cmdline[lpos]='_'; cmdline[lpos+1]=0;
//        FldSetTextPtr (fld=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, main_cmd)), cmdline);
//        FldDrawField (fld);
//        handled=1;
//      }
      if (c=='.') {
	newevent.eType=keyDownEvent;
	newevent.data.keyDown.chr=chrLineFeed;
	EvtAddEventToQueue (&newevent);
	break;
      }
      if (c==chrLineFeed) {
// provedeni prikazu...
	s=MemHandleLock (cmdline);
//        if (cmdline[lpos]=='_') cmdline[lpos]=0;
//        DoCommand (cmdline);
//DoCommand:
	cmd_par=s; while (*cmd_par) {if (*cmd_par>='a' && *cmd_par<='z') *cmd_par&=0x5F; cmd_par++;}
	StrCopyWord (cmd, s);
	switch (i=Dekoduj (cmd)) {
	  case DEK_NONE:
	      break;
	  case DEK_NACTI:
	    NactiJmena ((mode&EditType)?mestoDB:slovnikDB);
	    if (*cmd_par) {
	      for (i=0; i<lst_cnt; i++) {
		t=lists[i]; while (*t) {if (*t>='a' && *t<='z') *t&=0x5F; t++;}
		if (!StrCompare (cmd_par, lists[i])) break;
	      }
	      if (i>=lst_cnt) break;
	    } else {
	      LstSetListChoices (lst=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, name_list)), lists, lst_cnt);
	      i=(mode&EditType)?mestIdx:slovIdx;
	      if (i>=0 && i<lst_cnt) LstSetSelection (lst, i);
	      if ((i=LstPopupList (lst))<0) break;
	    }
	    if (mode&EditType) {
	      NactiMesto (mestIdx=i);
	      TiskniMesto (Tisk);
	    } else {
	      NactiSlovnik (slovIdx=i);
	    }
	    break;
	  case DEK_ULOZ:
	    NactiJmena ((mode&EditType)?mestoDB:slovnikDB);
	    if (mode&EditType) mode|=SaveType; else mode&=~SaveType;
	    if (*cmd_par) {
	      StrCopy (edit_mem, cmd_par);
	      if (mode&EditType) UlozMesto (); else UlozSlovnik ();
	      break;
	    }
	    i=(mode&EditType)?mestIdx:slovIdx;
	    if (i>=0 && i<lst_cnt) StrCopy (edit_mem, lists[i]); else *edit_mem=0;
	    FrmPopupForm (enter_form);
	    break;
	  case DEK_SMAZ:
	    if (mode&EditType) {
	      if (!FrmAlert (TXT_OSMAZATM)) {
		TiskniMesto (Mazani);
		if (mestIdx>=0 && mestIdx<DmNumRecords (mestoDB))
		  if (!FrmAlert (TXT_SMAZATZ)) {
		    DmRemoveRecord (mestoDB, mestIdx);
		    mestIdx=-1;
		  }
	      }
	    } else {
	      if (!FrmAlert (TXT_OSMAZAT)) {
		free_pos = 0;
		SetSat();
		if (slovIdx>=0 && slovIdx<DmNumRecords (slovnikDB))
		  if (!FrmAlert (TXT_SMAZATZ)) {
		    DmRemoveRecord (slovnikDB, slovIdx);
		    slovIdx=-1;
		  }
//                VypisSlovnik(0);
	      }
	    }
	    break;
	  case DEK_OPRAV:
	    if (mode&EditType) {HlasChybu (TXT_TNEMOHU, sysy[SYSY_OPRAV], NULL, NULL); break;}
	    switch (i=Dekoduj(cmd_par)) {
	      case DEK_UNKNOWN:
		HlasChybu(TXT_NEZNAM, cmd_par, NULL, NULL);
		break;
	      case DEK_NONE:
// zde bude vyber prikazu z listboxu
//                *edit_mem='\0';
//                mode|=EditMode;
//                FrmGotoForm (edit_form);
		if ((i=VypisSlovnik (frm, 0))<0) break;
		i+=POC_SLOVNIK;
	      default:
		if (i < POC_SLOVNIK)
		  HlasChybu(TXT_NROZLOZIT, (i<0)? sysy[i - DEK_NACTI] : jm[i], NULL, NULL);
		else {
		  *edit_mem='\0';
//                  mode|=EditMode;
		  Rozklad (i, edit_mem);
		  FrmGotoForm (edit_form);
		}
		break;
	    }
	    break;
	  case DEK_DEKADICKY:
	    MAX_ZNACEK=MAX_ZNACEK_d;
	    if (*cmd_par=='1') MAX_ZNACEK=MAX_ZNACEK_m;
	    break;
	  case DEK_UNKNOWN:
	    if (*cmd) {
	      if (mode&EditType) {HlasChybu (TXT_TNEMOHU, cmd, NULL, NULL); break;}
	      *edit_mem='\0';
//              mode|=EditMode;
	      StrPrintF (edit_mem, "%s %s\n  \n%s", cmd, txt[TXT_ZNAMENA-TXT_SLOVNIK], jm[DEK_KONEC]);
	      FrmGotoForm (edit_form);
	    }
	    break;
	  case DEK_SLOVNIK:
//            if (mode&EditType) {HlasChybu (TXT_TNEMOHU, jm[DEK_SLOVNIK], NULL, NULL); break;}
//            HlasChybu (TXT_NEUMIM_, jm[DEK_SLOVNIK], NULL, NULL);
//            *edit_mem='\0';
//            mode&=~EditMode;
//            VypisSlovnik();
//            FrmGotoForm (voc_form);
//            break;
	    if ((i=VypisSlovnik (frm, SHOW_SYSY|SHOW_BUILTIN))<0) break;
	    StrCopy (s, lists[i]);
	    newevent.eType=keyDownEvent;
	    newevent.data.keyDown.chr=chrLineFeed;
	    EvtAddEventToQueue (&newevent);
//            goto DoCommand;
	    break;
	  case DEK_MESTO:
	    if (mode&EditType) break;
	    mode|=EditType;
	    TiskPole (x, y, 0, dvorek[x][y]);
	    break;
	  case DEK_ROZKLAD:
	    if (mode&EditType) {HlasChybu (TXT_TNEMOHU, jm[DEK_ROZKLAD], NULL, NULL); break;}
	    switch (i=Dekoduj(cmd_par)) {
	      case DEK_UNKNOWN:
		if (*cmd_par=='*') {
		  for (i = POC_SLOVNIK; i < free_no; i++) {
		    Rozklad(i, edit_mem);
//                    mode&=~EditMode;
		    FrmGotoForm (view_form);
		  }
		} else
		  HlasChybu(TXT_NEZNAM, cmd_par, NULL, NULL);
		break;
	      case DEK_NONE:
		if ((i=VypisSlovnik (frm, 0))<0) break;
		i+=POC_SLOVNIK;
	      default:
		if (i < POC_SLOVNIK)
		  HlasChybu(TXT_NROZLOZIT, (i<0) ? sysy[i - DEK_NACTI] : jm[i], NULL, NULL);
		else {
//                  HlasChybu (TXT_NEUMIM_, jm[DEK_ROZKLAD], NULL, NULL);
		  Rozklad(i, edit_mem);
//                  mode&=~EditMode;
		  FrmGotoForm (view_form);
		}
		break;
	    }
	    break;
	  case DEK_CHYBA:
	    if (mode&EditType) {HlasChybu (TXT_TNEMOHU, jm[DEK_CHYBA], NULL, NULL); break;}
	    if (free_no == POC_SLOVNIK)
	      HlasChybu(TXT_NCZRUSIT, NULL, NULL, NULL);
	    else {
	      HlasChybu (TXT_ZRUSENO, jm[--free_no], NULL, NULL);
	      free_pos = (int) (jm[free_no] - sl);
	    }
	    break;
	  case DEK_KROK:
	    if (mode&EditType) {HlasChybu (TXT_TNEMOHU, jm[DEK_KROK], NULL, NULL); break;}
	    Krok();
	    break;
	  case DEK_VLEVO_VBOK:
	    if (mode&EditType) {HlasChybu (TXT_TNEMOHU, jm[DEK_VLEVO_VBOK], NULL, NULL); break;}
	    Vlevo();
	    break;
	  case DEK_POLOZ:
	    if (mode&EditType) {HlasChybu (TXT_TNEMOHU, jm[DEK_POLOZ], NULL, NULL); break;}
	    Poloz();
	    break;
	  case DEK_ZVEDNI:
	    if (mode&EditType) {HlasChybu (TXT_TNEMOHU, jm[DEK_ZVEDNI], NULL, NULL); break;}
	    Zvedni();
	    break;
	  case DEK_KDYZ:
	  case DEK_DOKUD:
	  case DEK_OPAKUJ:
	    HlasChybu(TXT_TNEMOHU, jm[i], NULL, NULL);
	    break;
	  case DEK_KONEC:
	    if (mode&EditType) {
	      mode&=~EditType;
	      TiskPole (x, y, smer+1, dvorek[x][y]);
	      break;
	    }
//            Terminate();
	    break;
	  default:
	    if (mode&EditType) {HlasChybu (TXT_TNEMOHU, jm[i], NULL, NULL); break;}
	    JedPrikaz(i);
	    break;
	}
//        *cmd='_'; cmd[1]=lpos=0;
//        FldSetTextPtr (fld=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, main_cmd)), cmd);
	i=StrLen (s);
	MemHandleUnlock (cmdline);
	fld=FrmGetObjectPtr (frm, fldI=FrmGetObjectIndex (frm, main_cmd));
//        FldSetSelection (fld, 0, 0);
	FldSetTextHandle (fld, cmdline);
//        FldDrawField (fld);
//        FldSetInsertionPoint (fld, 0);
//        FrmSetFocus (frm, fldI);
	FldSetSelection (fld, 0, i);
	FldDrawField (fld);
	handled=1;
      }
      break;
    case penDownEvent:
      if (mode&RunMode) break;
      i=event->screenX-MestoX-Okraj; j=event->screenY-MestoY-Okraj;
      if (i>=0 && i<MAX_X*Modul && j>=0 && j<MAX_Y*Modul) {
	i/=Modul; j=MAX_Y-j/Modul-1;
	if (mode&EditType) {
	  if (dvorek[i][j]==MAX_ZNACEK) dvorek[i][j]=0;
	  else
	  if (!dvorek[i][j]) dvorek[i][j]=ZED;
	  else
	  if (dvorek[i][j]==ZED) dvorek[i][j]=1;
	  else
	    dvorek[i][j]++;
	  if (dvorek[i][j]!=ZED && dvorek[i][j]>MAX_ZNACEK) dvorek[i][j]=0;
	  TiskPole (i, j, 0, dvorek[i][j]);
	} else {
	  if (i!=x || j!=y) {
	    TiskPole (x, y, 0, dvorek[x][y]);
	    TiskPole (x=i, y=j, smer+1, dvorek[i][j]);
	  }
	}
      }
      break;
    case penUpEvent:
      if (mode&RunMode) break;
      if (mode&EditType) break;
      i=event->data.penUp.start.x-MestoX-Okraj; j=event->data.penUp.start.y-MestoY-Okraj;
      if (i>=0 && i<MAX_X*Modul && j>=0 && j<MAX_Y*Modul) {
	i=event->data.penUp.end.x-event->data.penUp.start.x; j=event->data.penUp.end.y-event->data.penUp.start.y;
	if (((j<0)?-j:j)>((i<0)?-i:i)) {c=(j<0)?1:3; i=j;} else c=(i<0)?2:0;
	if (i<0) i=-i;
	if (i<Modul/2) break;
	TiskPole (x, y, (smer=c)+1, dvorek[x][y]);
      }
      break;

//    case ctlSelectEvent:  // A control button was pressed and released.
//      switch (event->data.ctlEnter.controlID) {
//      }
//      handled=1;
//      break;
    case menuEvent: // menu item was selected
      MenuEraseStatus (NULL);
      switch (event->data.menu.itemID) {
      case edit_cut:
	FldCut (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, main_cmd)));
	break;
      case edit_copy:
	FldCopy (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, main_cmd)));
	break;
      case edit_paste:
	FldPaste (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, main_cmd)));
	break;
      case edit_undo:
	FldUndo (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, main_cmd)));
	break;
      case main_about:
	FrmHelp (str_about);
	break;
      case main_help:
	FrmHelp (str_Mhelp);
	break;
      case main_loadm:
	NactiJmena (mestoDB);
	LstSetListChoices (lst=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, name_list)), lists, lst_cnt);
	if (mestIdx>=0 && mestIdx<lst_cnt) LstSetSelection (lst, mestIdx);
	if ((i=LstPopupList (lst))<0) break;
	NactiMesto (mestIdx=i);
	TiskniMesto (Tisk);
	break;
      case main_editm:
	mode|=EditType;
	TiskPole (x, y, 0, dvorek[x][y]);
	break;
      case main_savem:
	NactiJmena (mestoDB);
	if (mestIdx>=0 && mestIdx<lst_cnt) StrCopy (edit_mem, lists[mestIdx]); else *edit_mem=0;
	mode|=SaveType;
	FrmPopupForm (enter_form);
	break;
      case main_pop:
	TiskniMesto (Zvednuti);
	break;
      case main_delm:
	if (FrmAlert (TXT_OSMAZATM)) break;
	TiskniMesto (Mazani);
	if (mestIdx<0 || mestIdx>=DmNumRecords (mestoDB)) break;
	if (FrmAlert (TXT_SMAZATZ)) break;
	DmRemoveRecord (mestoDB, mestIdx);
	mestIdx=-1;
	break;
      case main_loads:
	NactiJmena (slovnikDB);
	LstSetListChoices (lst=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, name_list)), lists, lst_cnt);
	if (slovIdx>=0 && slovIdx<lst_cnt) LstSetSelection (lst, slovIdx);
	if ((i=LstPopupList (lst))<0) break;
	NactiSlovnik (slovIdx=i);
	break;
      case main_edits:
	*edit_mem='\0';
//        mode|=EditMode;
	if (free_no>DEK_KONEC+1) Rozklad (free_no-1, edit_mem);
	FrmGotoForm (edit_form);
	break;
      case main_saves:
	NactiJmena (slovnikDB);
	if (slovIdx>=0 && slovIdx<lst_cnt) StrCopy (edit_mem, lists[slovIdx]); else *edit_mem=0;
	mode&=~SaveType;
	FrmPopupForm (enter_form);
	break;
      case main_dels:
	if (FrmAlert (TXT_OSMAZAT)) break;
	free_pos = 0;
	SetSat();
	if (slovIdx<0 || slovIdx>=DmNumRecords (slovnikDB)) break;
	if (FrmAlert (TXT_SMAZATZ)) break;
	DmRemoveRecord (slovnikDB, slovIdx);
	slovIdx=-1;
	break;
      }
      handled = 1;
      break;
  }
  return handled;
}

// uprava pozice scrollbaru
static void UpdateScrollbar (FormPtr frm, UInt16 find, UInt16 sind) {
UInt16          currPos, txtHeight, fldHeight, maxValue;
  FldGetScrollValues (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, find)), &currPos, &txtHeight, &fldHeight);
  if (txtHeight>fldHeight) maxValue=txtHeight-fldHeight;
  else
  if (currPos) maxValue=currPos;
  else maxValue=0;
  SclSetScrollBar (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, sind)), currPos, 0, maxValue, fldHeight-1);
}

static void ScrollLines (FormPtr frm, UInt16 find, UInt16 sind, int numLines, Boolean redraw) {
FieldPtr        fld;

  fld=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, find));
  if (numLines<0)
    FldScrollField (fld, -numLines, winUp);
  else
    FldScrollField (fld, numLines, winDown);
  if (FldGetNumberOfBlankLines (fld) && numLines<0 || redraw)
    UpdateScrollbar (frm, find, sind);
}

// edit event handler
static Boolean EditEventHandler (EventPtr event) {
FormPtr         frm;
int             handled = 0;
FieldPtr        fld;
FieldAttrType   Fattr;
UInt16          fldI;
int             i;

  frm = FrmGetActiveForm ();
  switch (event->eType) {
    case frmOpenEvent:
      FldSetTextHandle (fld=FrmGetObjectPtr (frm, fldI=FrmGetObjectIndex (frm, edit_lines)), edit_hnd);
/*      FldGetAttributes (fld, &Fattr);
      if (mode&EditMode) {
	Fattr.editable=1;
	Fattr.underlined=grayUnderline;
      } else {
	Fattr.editable=0;
	Fattr.underlined=noUnderline;
      }
      FldSetAttributes (fld, &Fattr); */
      UpdateScrollbar (frm, edit_lines, edit_scroll);
//      CtlSetUsable (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, edit_cancel)), (mode&EditMode)?1:0);
      FrmDrawForm (frm);
//      if (mode&EditMode) {
	i=0;
	while (edit_mem[i] && edit_mem[i]!='\n') i++;
	if (edit_mem[i]) i++;
	while (edit_mem[i] && edit_mem[i]==' ') i++;
	FldSetInsertionPoint (fld, i);
	FrmSetFocus (frm, fldI);
//      }
      handled = 1;
      break;
    case frmCloseEvent:
      FldSetTextHandle (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, edit_lines)), NULL);
      break;
    case fldChangedEvent:
      UpdateScrollbar (frm, edit_lines, edit_scroll);
      handled=1;
      break;
    case sclRepeatEvent:
      ScrollLines (frm, edit_lines, edit_scroll, event->data.sclRepeat.newValue - event->data.sclRepeat.value, false);
      break;
    case keyDownEvent:
      if (event->data.keyDown.chr==chrPageUp || event->data.keyDown.chr==chrPageDown) {
	i=FldGetVisibleLines (fld=FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, edit_lines)));
	if (event->data.keyDown.chr==chrPageUp) i=-i;
	ScrollLines (frm, edit_lines, edit_scroll, i, true);
      }
      break;
    case ctlSelectEvent:  // A control button was pressed and released.
      switch (event->data.ctlEnter.controlID) {
	case edit_ok:
	  if (mode&EditMode) {
	    DefinujPrikaz (MemHandleLock (edit_hnd));
	    MemHandleUnlock (edit_hnd);
	  }
	case edit_cancel:
	  FrmGotoForm (main_form);
	  handled=1;
      }
      break;
    case menuEvent:
      MenuEraseStatus (NULL);
      switch (event->data.menu.itemID) {
	case edit_cut:
//          if (mode&EditMode)
	    FldCut (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, edit_lines)));
	  break;
	case edit_copy:
	  FldCopy (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, edit_lines)));
	  break;
	case edit_paste:
//          if (mode&EditMode)
	    FldPaste (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, edit_lines)));
	  break;
	case edit_undo:
	  FldUndo (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, edit_lines)));
	  break;
	case edit_grfhelp:
	  SysGraffitiReferenceDialog (referenceDefault);
	  break;
	case edit_help:
	  FrmHelp (edit_helpstr);
	  break;
      }
      handled=1;
  }
  return handled;
}

static Boolean EnterEventHandler (EventPtr event) {
FormPtr         frm;
FieldPtr        fld;
UInt16          fldI;
int             i;
int             handled = 0;

  frm=FrmGetActiveForm ();
  switch (event->eType) {
    case frmOpenEvent:
      FldSetTextHandle (fld=FrmGetObjectPtr (frm, fldI=FrmGetObjectIndex (frm, enter_name)), edit_hnd);
      FrmDrawForm (frm);
      FldSetSelection (fld, 0, StrLen (edit_mem));
      FrmSetFocus (frm, fldI);
      handled=1;
      break;
//    case frmCloseEvent:
//    case appStopEvent:
//      break;
    case ctlSelectEvent:
      switch (event->data.ctlEnter.controlID) {
	case enter_ok:
	  if (mode&SaveType) {
	    UlozMesto ();
	  } else {
	    UlozSlovnik();
	  }
	case enter_cancel:
	  FldSetTextHandle (FrmGetObjectPtr (frm, FrmGetObjectIndex (frm, enter_name)), NULL);
	  FrmReturnToForm (main_form);
	  break;
      }
      handled=1;
      break;
  }
  return handled;
}

// application event handler
static Boolean AppHandleEvent (EventPtr event) {
int         formID;
FormPtr     form;
short       err;

  if (event->eType == frmLoadEvent) {
    formID = event->data.frmLoad.formID;
    form = FrmInitForm (formID);
    FrmSetActiveForm (form);
    switch (formID) {
    case main_form:
      FrmSetEventHandler (form, (FormEventHandlerPtr) MainEventHandler);
      break;
    case edit_form:
      mode|=EditMode;
      FrmSetEventHandler (form, (FormEventHandlerPtr) EditEventHandler);
      break;
//    case voc_form:
    case view_form:
      mode&=~EditMode;
      FrmSetEventHandler (form, (FormEventHandlerPtr) EditEventHandler);
      break;
    case enter_form:
      FrmSetEventHandler (form, (FormEventHandlerPtr) EnterEventHandler);
      break;
    }
  }
  return FrmDispatchEvent (event);
}

// runtime event handler
int TestKbd(void) {
EventType       event;
int             i;

  if (EvtEventAvail ()) {
// kopie EventLoop...
    EvtGetEvent (&event, 3);
    if (!SysHandleEvent (&event)) {
//      if (!MenuHandleEvent (NULL, &event, &err)) {
	if (event.eType==sclRepeatEvent) {
	  paus_pos=i=event.data.sclRepeat.newValue;
	  pause=0;
	  while (i--) pause+=(pause/6+1);
	}
	AppHandleEvent (&event);
//      }
    }
    if (event.eType == appStopEvent)
      chyba++;
  }
  if (KeyCurrentState ()&keyBitPageDown)
    chyba=1;
  return (chyba);
}

// main event loop
static void EventLoop(void) {
short       err;
int         formID;
FormPtr     form;
EventType   event;

  do {
    EvtGetEvent (&event, -1);
    if (SysHandleEvent (&event)) continue;
    if (MenuHandleEvent (NULL, &event, &err)) continue;
    AppHandleEvent (&event);
  } while (event.eType != appStopEvent);
}

/***************************************************************************
 *      P a l m O S   S t a r t U p   C o d e                              *
 ***************************************************************************/

// allocate dynaic memory, create working structures, open databases...
static int StartApplication(void) {
int             i;
Err             err;
WinHandle       oldwin;
BitmapType      *BMP;
MemHandle       RecHandle;
char            *s;
UInt16          idx;
LocalID         db_id;
UInt32          version, density;
// pro HiRes SONY detekci...
UInt16          refNum;

// create bitmaps
  version=0;
  density=kDensityLow;
  err = FtrGet(sysFtrCreator, sysFtrNumWinVersion, &version);
  if (version>=4) {
    // kvuli SONY HiRes musim nejprve zjistit, jestli je to SONY HiRes
    // zkusim najit HiRes knihovnu
    err=SysLibFind ("Sony HR Library", &refNum);
    if (err)
      err=SysLibLoad ('libr', 'SlHr', &refNum);
    if (!err) { // SONY HiRes device
    } else { // PalmOS 5 HiDensity device
      WinScreenGetAttribute(winScreenDensity, &density);
    }
  }
  bitwin=WinCreateOffscreenWindow (BITMAPS*Modul, Modul, (density!=kDensityLow)?nativeFormat:screenFormat, &err);
  oldwin=WinSetDrawWindow (bitwin);
  BMP=MemHandleLock (DmGetResource (bitmapRsc, karel_vse));
  // pokud zerizeni umi HiRes, tak nactu odpovidajici bitmapy
  WinDrawBitmap (BMP, 0, 0);
  MemPtrUnlock (BMP);
  WinSetDrawWindow (oldwin);
// setting global variables
  x=y=smer=mode=chyba=0;
  paus_pos=DEF_PAUSE;
  MAX_ZNACEK=MAX_ZNACEK_d;
  if (density!=kDensityLow) MAX_ZNACEK=MAX_ZNACEK_m;
  last_time=0;
  edit_mem=MemHandleLock (edit_hnd=MemHandleNew (EditLen));
  sl=MemHandleLock (sl_hnd=MemHandleNew (MAX_SL));
  lists[0]=MemHandleLock (lst_hnd=MemHandleNew ((NameLen+1)*NameCnt));
  for (i=1; i<NameCnt; i++) {
    lists[i]=&lists[i-1][NameLen+1];
  }
  slovIdx=mestIdx=-1;
  cmdline=MemHandleNew (LineLen+1);
// loading string resources
  for (i=0; i<MAX_TXT_RC; i++) {
    RecHandle=DmGetResource(strRsc, TXT_SLOVNIK+i);
    err=MemHandleSize (RecHandle);
    txthnd[i]=MemHandleNew (err);
    txt[i]=MemHandleLock (txthnd[i]);
    StrCopy (txt[i], MemHandleLock (RecHandle));
    MemHandleUnlock (RecHandle);
    DmReleaseResource (RecHandle);
    s=txt[i];
    while (*s) {if (*s=='|') *s='\0'; s++;}
  }
// opening databases
  mestoDB=DmOpenDatabaseByTypeCreator (MestoID, AppID, dmModeReadWrite);
  if (!mestoDB) {
    if (DmCreateDatabase (0, mestoName, AppID, MestoID, false)) return 1;
    db_id=DmFindDatabase (0, mestoName);
    DmDatabaseInfo (0, db_id, NULL, &idx, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
    idx|=dmHdrAttrBackup;
    DmSetDatabaseInfo (0, db_id, NULL, &idx, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
    mestoDB=DmOpenDatabaseByTypeCreator (MestoID, AppID, dmModeReadWrite);
  }
  slovnikDB=DmOpenDatabaseByTypeCreator (SlovnikID, AppID, dmModeReadWrite);
  if (!slovnikDB) {
    if (DmCreateDatabase (0, slovnikName, AppID, SlovnikID, false)) return 1;
    db_id=DmFindDatabase (0, slovnikName);
    DmDatabaseInfo (0, db_id, NULL, &idx, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
    idx|=dmHdrAttrBackup;
    DmSetDatabaseInfo (0, db_id, NULL, &idx, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
    slovnikDB=DmOpenDatabaseByTypeCreator (SlovnikID, AppID, dmModeReadWrite);
  }
  VytvorSlovnik ();
// nacteni preferenci
  idx=0;
  if (PrefGetAppPreferences (AppID, 0, NULL, &idx, false)!=noPreferenceFound)
    if (idx==sizeof (prefs)) {
      PrefGetAppPreferences (AppID, 0, &prefs, &idx, false);
      x=prefs.x; y=prefs.y; smer=prefs.smer; slovIdx=prefs.slovIdx; mestIdx=prefs.mestIdx; paus_pos=prefs.paus_pos;
    }
  idx=0;
  if (PrefGetAppPreferences (AppID, 1, NULL, &idx, false)!=noPreferenceFound)
    if (idx==sizeof (dvorek))
      PrefGetAppPreferences (AppID, 1, dvorek, &idx, false);
  idx=0;
  if (PrefGetAppPreferences (AppID, 2, NULL, &idx, false)!=noPreferenceFound)
    if (idx<MAX_SL) {
      PrefGetAppPreferences (AppID, 2, sl, &idx, false);
      free_pos=idx;
      SetSat ();
    }
// go to main form
  FrmGotoForm (main_form);
  return 0;
}

// free dynamic memory
static void StopApplication (void) {
int i;
  prefs.x=x; prefs.y=y; prefs.smer=smer; prefs.mestIdx=mestIdx; prefs.slovIdx=slovIdx; prefs.paus_pos=paus_pos;
  PrefSetAppPreferences (AppID, 0, 0, &prefs, sizeof (prefs), false);
  PrefSetAppPreferences (AppID, 1, 0, dvorek, sizeof (dvorek), false);
  PrefSetAppPreferences (AppID, 2, 0, sl, free_pos, false);
  WinDeleteWindow (bitwin, false);
  MemHandleUnlock (edit_hnd);
  MemHandleFree (edit_hnd);
  MemHandleUnlock (sl_hnd);
  MemHandleFree (sl_hnd);
  MemHandleUnlock (lst_hnd);
  MemHandleFree (lst_hnd);
  MemHandleFree (cmdline);
  for (i=0; i<MAX_TXT_RC; i++) {
    MemHandleUnlock (txthnd[i]);
    MemHandleFree (txthnd[i]);
  }
  DmCloseDatabase (mestoDB);
  DmCloseDatabase (slovnikDB);
  return;
}

// PalmOS Main Function
UInt32  PilotMain (UInt16 cmd, void *cmdPBP, UInt16 launchFlags) {
int error;

  if (cmd == sysAppLaunchCmdNormalLaunch) {
    if (error = StartApplication()) return error;
    EventLoop ();
    StopApplication ();
  }
  return 0;
}
